// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_geo_msgs:msg/GeoJSONGeometry.idl
// generated code does not contain a copyright notice
#include "tuw_geo_msgs/msg/detail/geo_json_geometry__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `coordinates`
#include "geographic_msgs/msg/detail/geo_point__functions.h"
// Member `properties`
#include "tuw_geo_msgs/msg/detail/geo_json_properties__functions.h"

bool
tuw_geo_msgs__msg__GeoJSONGeometry__init(tuw_geo_msgs__msg__GeoJSONGeometry * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    tuw_geo_msgs__msg__GeoJSONGeometry__fini(msg);
    return false;
  }
  // coordinates
  if (!geographic_msgs__msg__GeoPoint__Sequence__init(&msg->coordinates, 0)) {
    tuw_geo_msgs__msg__GeoJSONGeometry__fini(msg);
    return false;
  }
  // properties
  if (!tuw_geo_msgs__msg__GeoJSONProperties__init(&msg->properties)) {
    tuw_geo_msgs__msg__GeoJSONGeometry__fini(msg);
    return false;
  }
  return true;
}

void
tuw_geo_msgs__msg__GeoJSONGeometry__fini(tuw_geo_msgs__msg__GeoJSONGeometry * msg)
{
  if (!msg) {
    return;
  }
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // coordinates
  geographic_msgs__msg__GeoPoint__Sequence__fini(&msg->coordinates);
  // properties
  tuw_geo_msgs__msg__GeoJSONProperties__fini(&msg->properties);
}

bool
tuw_geo_msgs__msg__GeoJSONGeometry__are_equal(const tuw_geo_msgs__msg__GeoJSONGeometry * lhs, const tuw_geo_msgs__msg__GeoJSONGeometry * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // coordinates
  if (!geographic_msgs__msg__GeoPoint__Sequence__are_equal(
      &(lhs->coordinates), &(rhs->coordinates)))
  {
    return false;
  }
  // properties
  if (!tuw_geo_msgs__msg__GeoJSONProperties__are_equal(
      &(lhs->properties), &(rhs->properties)))
  {
    return false;
  }
  return true;
}

bool
tuw_geo_msgs__msg__GeoJSONGeometry__copy(
  const tuw_geo_msgs__msg__GeoJSONGeometry * input,
  tuw_geo_msgs__msg__GeoJSONGeometry * output)
{
  if (!input || !output) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // coordinates
  if (!geographic_msgs__msg__GeoPoint__Sequence__copy(
      &(input->coordinates), &(output->coordinates)))
  {
    return false;
  }
  // properties
  if (!tuw_geo_msgs__msg__GeoJSONProperties__copy(
      &(input->properties), &(output->properties)))
  {
    return false;
  }
  return true;
}

tuw_geo_msgs__msg__GeoJSONGeometry *
tuw_geo_msgs__msg__GeoJSONGeometry__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geo_msgs__msg__GeoJSONGeometry * msg = (tuw_geo_msgs__msg__GeoJSONGeometry *)allocator.allocate(sizeof(tuw_geo_msgs__msg__GeoJSONGeometry), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_geo_msgs__msg__GeoJSONGeometry));
  bool success = tuw_geo_msgs__msg__GeoJSONGeometry__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_geo_msgs__msg__GeoJSONGeometry__destroy(tuw_geo_msgs__msg__GeoJSONGeometry * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_geo_msgs__msg__GeoJSONGeometry__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__init(tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geo_msgs__msg__GeoJSONGeometry * data = NULL;

  if (size) {
    data = (tuw_geo_msgs__msg__GeoJSONGeometry *)allocator.zero_allocate(size, sizeof(tuw_geo_msgs__msg__GeoJSONGeometry), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_geo_msgs__msg__GeoJSONGeometry__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_geo_msgs__msg__GeoJSONGeometry__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__fini(tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_geo_msgs__msg__GeoJSONGeometry__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_geo_msgs__msg__GeoJSONGeometry__Sequence *
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * array = (tuw_geo_msgs__msg__GeoJSONGeometry__Sequence *)allocator.allocate(sizeof(tuw_geo_msgs__msg__GeoJSONGeometry__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__destroy(tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__are_equal(const tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * lhs, const tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_geo_msgs__msg__GeoJSONGeometry__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_geo_msgs__msg__GeoJSONGeometry__Sequence__copy(
  const tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * input,
  tuw_geo_msgs__msg__GeoJSONGeometry__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_geo_msgs__msg__GeoJSONGeometry);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_geo_msgs__msg__GeoJSONGeometry * data =
      (tuw_geo_msgs__msg__GeoJSONGeometry *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_geo_msgs__msg__GeoJSONGeometry__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_geo_msgs__msg__GeoJSONGeometry__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_geo_msgs__msg__GeoJSONGeometry__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
