// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_geo_msgs:msg/GeoJSONGeometry.idl
// generated code does not contain a copyright notice

#ifndef TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_GEOMETRY__STRUCT_HPP_
#define TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_GEOMETRY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'coordinates'
#include "geographic_msgs/msg/detail/geo_point__struct.hpp"
// Member 'properties'
#include "tuw_geo_msgs/msg/detail/geo_json_properties__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSONGeometry __attribute__((deprecated))
#else
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSONGeometry __declspec(deprecated)
#endif

namespace tuw_geo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeoJSONGeometry_
{
  using Type = GeoJSONGeometry_<ContainerAllocator>;

  explicit GeoJSONGeometry_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : properties(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  explicit GeoJSONGeometry_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : type(_alloc),
    properties(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  // field types and members
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _coordinates_type =
    std::vector<geographic_msgs::msg::GeoPoint_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geographic_msgs::msg::GeoPoint_<ContainerAllocator>>>;
  _coordinates_type coordinates;
  using _properties_type =
    tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>;
  _properties_type properties;

  // setters for named parameter idiom
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__coordinates(
    const std::vector<geographic_msgs::msg::GeoPoint_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geographic_msgs::msg::GeoPoint_<ContainerAllocator>>> & _arg)
  {
    this->coordinates = _arg;
    return *this;
  }
  Type & set__properties(
    const tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> & _arg)
  {
    this->properties = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSONGeometry
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSONGeometry
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONGeometry_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeoJSONGeometry_ & other) const
  {
    if (this->type != other.type) {
      return false;
    }
    if (this->coordinates != other.coordinates) {
      return false;
    }
    if (this->properties != other.properties) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeoJSONGeometry_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeoJSONGeometry_

// alias to use template instance with default allocator
using GeoJSONGeometry =
  tuw_geo_msgs::msg::GeoJSONGeometry_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_geo_msgs

#endif  // TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_GEOMETRY__STRUCT_HPP_
